﻿using LawFirmContracts.BindingModels;
using LawFirmContracts.ViewModels;
using LawFirmDataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace LawFirmDatabaseImplement.Models
{
    [DataContract]
    public class Blank : IBlankModel
    {
        [DataMember]
        public int Id { get; private set; }
        [Required]
        [DataMember]
        public string BlankName { get; private set; } = String.Empty;

        [Required]
        [DataMember]
        public double Cost { get; set; }

        [ForeignKey("BlankId")]
        public virtual List<DocumentBlank> DocumentBlanks { get; set; } = new();

        public static Blank? Create(BlankBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new Blank()
            {
                Id = model.Id,
                BlankName = model.BlankName,
                Cost = model.Cost
            };
        }

        public void Update(BlankBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            BlankName = model.BlankName;
            Cost = model.Cost;
        }
        public BlankViewModel GetViewModel => new()
        {
            Id = Id,
            BlankName = BlankName,
            Cost = Cost
        };
    }
}
